// AUTOGENERATED - DO NOT EDIT

package tdlib

import (
	"encoding/json"
	"fmt"
)

// StickerSetInfo Represents short information about a sticker set
type StickerSetInfo struct {
	tdCommon
	ID          JSONInt64  `json:"id"`           // Identifier of the sticker set
	Title       string     `json:"title"`        // Title of the sticker set
	Name        string     `json:"name"`         // Name of the sticker set
	Thumbnail   *Thumbnail `json:"thumbnail"`    // Sticker set thumbnail in WEBP or TGS format with width and height 100; may be null
	IsInstalled bool       `json:"is_installed"` // True, if the sticker set has been installed by current user
	IsArchived  bool       `json:"is_archived"`  // True, if the sticker set has been archived. A sticker set can't be installed and archived simultaneously
	IsOfficial  bool       `json:"is_official"`  // True, if the sticker set is official
	IsAnimated  bool       `json:"is_animated"`  // True, is the stickers in the set are animated
	IsMasks     bool       `json:"is_masks"`     // True, if the stickers in the set are masks
	IsViewed    bool       `json:"is_viewed"`    // True for already viewed trending sticker sets
	Size        int32      `json:"size"`         // Total number of stickers in the set
	Covers      []Sticker  `json:"covers"`       // Contains up to the first 5 stickers from the set, depending on the context. If the application needs more stickers the full set should be requested
}

// MessageType return the string telegram-type of StickerSetInfo
func (stickerSetInfo *StickerSetInfo) MessageType() string {
	return "stickerSetInfo"
}

// NewStickerSetInfo creates a new StickerSetInfo
//
// @param iD Identifier of the sticker set
// @param title Title of the sticker set
// @param name Name of the sticker set
// @param thumbnail Sticker set thumbnail in WEBP or TGS format with width and height 100; may be null
// @param isInstalled True, if the sticker set has been installed by current user
// @param isArchived True, if the sticker set has been archived. A sticker set can't be installed and archived simultaneously
// @param isOfficial True, if the sticker set is official
// @param isAnimated True, is the stickers in the set are animated
// @param isMasks True, if the stickers in the set are masks
// @param isViewed True for already viewed trending sticker sets
// @param size Total number of stickers in the set
// @param covers Contains up to the first 5 stickers from the set, depending on the context. If the application needs more stickers the full set should be requested
func NewStickerSetInfo(iD JSONInt64, title string, name string, thumbnail *Thumbnail, isInstalled bool, isArchived bool, isOfficial bool, isAnimated bool, isMasks bool, isViewed bool, size int32, covers []Sticker) *StickerSetInfo {
	stickerSetInfoTemp := StickerSetInfo{
		tdCommon:    tdCommon{Type: "stickerSetInfo"},
		ID:          iD,
		Title:       title,
		Name:        name,
		Thumbnail:   thumbnail,
		IsInstalled: isInstalled,
		IsArchived:  isArchived,
		IsOfficial:  isOfficial,
		IsAnimated:  isAnimated,
		IsMasks:     isMasks,
		IsViewed:    isViewed,
		Size:        size,
		Covers:      covers,
	}

	return &stickerSetInfoTemp
}
